/**
 * Klasse Figure71Test
 *
 * This is GPL'd code
 * (c) by Patrick Kilian 2003
 *
 * Testklasse zu FigureComponent
 * @author Patrick Kilian
 * @version 1.00
 */
public class Figure71Test {
    /**
     * Testfunktion
     *
     * @param args wird ignoriert
     */
    public static void main(String[] args) {
        Figure71 temp;
        Figure71Component fc = new Figure71Component(20);
        fc.addFigure((Figure71) new Rectangle71 (0, 0, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (0, 2, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (0, 4, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (1, 1, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (1, 3, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (2, 0, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (2, 2, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (2, 4, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (3, 1, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (3, 3, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (4, 0, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (4, 2, 1, 1));
        fc.addFigure((Figure71) new Rectangle71 (4, 4, 1, 1));
        fc.addFigure((Figure71) new Circle71 (2.5, 2.5, 1));
        fc.addFigure((Figure71) new Rectangle71 (-7, -3, 6, 1));
        fc.addFigure((Figure71) new Circle71 (-5, -5, 2));
        System.out.println("Gesamtflche: " + fc.area());
        System.out.println("Umfang: " + fc.circumference());
        for (int i = 0; i < 16; i++) {
            temp = fc.getFigure(i);
            System.out.println(i + " ist: " + temp.toString());
            System.out.println("A ist: " + temp.area());
            System.out.println("U ist: " + temp.circumference());
        }
        testWithPoint(fc, -1, 0);
        testWithPoint(fc, 0.5, 0.5);
        testWithPoint(fc, 2.5, 2.5);
        testWithPoint(fc, 1.1, 0.6);
        testWithPoint(fc, 2.3, 1.9);
        testWithPoint(fc, 4.7, 2.4);
        testWithPoint(fc, 1.9, 1.7);
        testWithPoint(fc, 3.2, 4.0);
        testWithPoint(fc, 4.0, 1.9);
        testWithPoint(fc, 0.5, 0.7);
        testWithPoint(fc, 4.4, 2.2);
    }
    /**
     * Fhrt den berdeckungstest mit dem Punkt (x|) am Comonenten-Array f
     * durch
     * @param f das Componenten-Array
     * @param x x-Koordinate
     * @param y y-Koordinate
     */
    private static void testWithPoint(Figure71Component f, double x, double y) {
        if (f.overlaps(x, y) == true) {
            System.out.println("berdeckung mit: x=" + x + ", y=" +y);
        } else {
            System.out.println("Freie Stelle bei: x=" + x +", y=" +y);
        }
    }
}
